.container:
  variables:
    PIT_DOCKERFILE: "Dockerfile"
    PIT_DOCKER_ARGS: ""
  image:
    name: "$PIT_BUILD_IMAGE"
    entrypoint: [""]
  artifacts:
    reports:
      dotenv: build.env
  rules:
    - if: '$PIT_SKIP_BUILD == "1"'
      when: never

#
# Docker
#
.docker:
  extends: .container
  variables:
    PIT_BUILD_IMAGE: "$PIT_IMAGE_BASE_PATH/build/docker"
    PIT_SKIP_DOCKER_PUSH: "0"
    DOCKER_HOST: "tcp://docker:2375"
    DOCKER_TLS_CERTDIR: ""
  services:
    - docker:19-dind
  tags:
    - docker
  
.build:docker:
  stage: build
  extends: .docker
  script:
    - powerodit build $PIT_DOCKERFILE

.release:docker:
  extends: .docker
  variables:
    GIT_STRATEGY: none
  stage: release

.release:docker:branch:
  extends: .release:docker
  script:
    - powerodit release "$CI_COMMIT_REF_SLUG"

.release:docker:tag:
  extends: .release:docker
  script:
    - powerodit release "$CI_COMMIT_TAG"
  rules:
    - if: '$PIT_SKIP_BUILD == "1"'
      when: never
    - if: '$CI_COMMIT_TAG'

.release:docker:latest:
  extends: .release:docker
  script:
    - powerodit release "latest"
  rules:
    - if: '$PIT_SKIP_BUILD == "1"'
      when: never
    - if: '$PIT_SKIP_RELEASE'
      when: never
    - if: '$CI_COMMIT_BRANCH == "master"'
    - if: '$CI_COMMIT_BRANCH == "production"'

#
# Kaniko
#

.kaniko:
  extends: .container
  variables:
    PIT_BUILD_IMAGE: "$PIT_IMAGE_BASE_PATH/build/kaniko"

.build:kaniko:
  stage: build
  extends: .kaniko
  script:
    - powerodit build $PIT_DOCKERFILE $PIT_RC_IMAGE

.release:kaniko:
  stage: release
  extends: .kaniko
  variables:
    GIT_STRATEGY: none
  script:
    - powerodit release $PIT_RC_IMAGE $PIT_GM_IMAGE

.release:kaniko:latest:
  extends: .release:kaniko
  script:
    - powerodit release $PIT_RC_IMAGE "$CI_REGISTRY_IMAGE:latest"
  rules:
    - if: '$PIT_SKIP_BUILD == "1"'
      when: never
    - if: '$PIT_SKIP_RELEASE'
      when: never
    - if: '$CI_COMMIT_BRANCH == "master"'
    - if: '$CI_COMMIT_BRANCH == "production"'

#
# BuildKit
#

.buildkit:
  extends: .container
  variables:
    PIT_BUILD_IMAGE: "$PIT_IMAGE_BASE_PATH/build/buildkit"

.build:buildkit:
  stage: build
  extends: .buildkit
  script:
    - powerodit build $PIT_DOCKERFILE

.release:buildkit:
  extends: .buildkit
  variables:
    GIT_STRATEGY: none
  stage: release

.release:buildkit:branch:
  extends: .release:buildkit
  script:
    - powerodit release "$CI_COMMIT_REF_SLUG"

.release:buildkit:tag:
  extends: .release:buildkit
  script:
    - powerodit release "$CI_COMMIT_TAG"
  rules:
    - if: '$PIT_SKIP_BUILD == "1"'
      when: never
    - if: '$CI_COMMIT_TAG'

.release:buildkit:latest:
  extends: .release:buildkit
  script:
    - powerodit release "latest"
  rules:
    - if: '$PIT_SKIP_BUILD == "1"'
      when: never
    - if: '$CI_COMMIT_BRANCH == "master"'
    - if: '$CI_COMMIT_BRANCH == "production"'
